<template>
  <MainLayout>
    <HeaderContainer slot="header" />
    <nuxt />
  </MainLayout>
</template>

<script>
import MainLayout from '../components/mainLayout/MainLayout';
import HeaderContainer from '../containers/header/HeaderContainer';

export default {
  name: 'DefaultLayout',
  components: { HeaderContainer, MainLayout },
  watch: {
    '$store.state.common.language': function (lang) {
      this.$i18n.locale = lang;
    },
  },

  async mounted() {
    window.addEventListener('resize', this.handleBreakpoints);

    this.handleBreakpoints();

    await this.$store.dispatch('references/fetchPrices');
    await this.$store.dispatch('references/fetchAssets');
    const assets = this.$store.getters['references/assets'].map(({ id }) => id);
    this.$store.commit('common/setAsset', assets.indexOf('bitcoin') > -1 ? 'bitcoin' : assets[0]);
    this.$store.dispatch('references/subscribeOnPrices');
  },
  beforeDestroy() {
    window.removeEventListener('resize', this.handleBreakpoints);
  },
  methods: {
    handleBreakpoints() {
      this.$store.commit('bp/handle', window.innerWidth);
    },
  },
};
</script>

<style lang="scss">
  @import "../assets/drop";
  @import "../assets/root";
</style>
